"""Generated message classes for ml version v1alpha3.

An API to enable creating and using machine learning models.
"""
# NOTE: This file is autogenerated and should not be edited by hand.

from apitools.base.protorpclite import messages as _messages
from apitools.base.py import encoding
from apitools.base.py import extra_types


package = 'ml'


class GoogleCloudMlV1alpha2Analysis(_messages.Message):
  """Represents analysis of a trained model.

  Fields:
    classification: The analysis of a classification model.
    regression: The analysis of a regression model.
  """

  classification = _messages.MessageField('GoogleCloudMlV1alpha2ClassificationAnalysis', 1)
  regression = _messages.MessageField('GoogleCloudMlV1alpha2RegressionAnalysis', 2)


class GoogleCloudMlV1alpha2ClassificationAnalysis(_messages.Message):
  """Represents the analysis of a trained classification model.

  Fields:
    error: The error rate of a classification model.
  """

  error = _messages.FloatField(1)


class GoogleCloudMlV1alpha2ClassificationConfig(_messages.Message):
  """Represents the definition of a classification model.

  Fields:
    tensorflowGraph: Options for classification using a custom TensorFlow
      graph.
  """

  tensorflowGraph = _messages.MessageField('GoogleCloudMlV1alpha2TensorFlowGraph', 1)


class GoogleCloudMlV1alpha2DataSet(_messages.Message):
  """Represents data to be used within training and prediction.

  Fields:
    files: A dataset comprised of a set of individual files or objects within
      Cloud Storage.
    inline: A dataset comprised of a set of individual instances inlined. The
      number of instances is limited based on constraints of individual
      methods.
  """

  files = _messages.MessageField('GoogleCloudMlV1alpha2StorageData', 1)
  inline = _messages.MessageField('GoogleCloudMlV1alpha2InlineData', 2)


class GoogleCloudMlV1alpha2EvaluationJob(_messages.Message):
  """Represents a specification for an evaluation job.

  Fields:
    evalData: The data to evaluate over.
    outputUri: The storage location of a folder to write out the evaluation
      outputs.
  """

  evalData = _messages.MessageField('GoogleCloudMlV1alpha2DataSet', 1)
  outputUri = _messages.StringField(2)


class GoogleCloudMlV1alpha2InlineData(_messages.Message):
  """Represents inlined data.

  Fields:
    instances: The list of data instances.
  """

  instances = _messages.StringField(1, repeated=True)


class GoogleCloudMlV1alpha2JobResult(_messages.Message):
  """Represents the results of a training, prediction or evaluation job.

  Fields:
    analysis: The analysis of a trained model for training or evaluation jobs.
    outputFiles: The list of generated output files.
  """

  analysis = _messages.MessageField('GoogleCloudMlV1alpha2Analysis', 1)
  outputFiles = _messages.StringField(2, repeated=True)


class GoogleCloudMlV1alpha2ModelSpec(_messages.Message):
  """Represents the specification of a model.

  Fields:
    classification: The configuration for classification models.
    regression: The configuration for regression models.
  """

  classification = _messages.MessageField('GoogleCloudMlV1alpha2ClassificationConfig', 1)
  regression = _messages.MessageField('GoogleCloudMlV1alpha2RegressionConfig', 2)


class GoogleCloudMlV1alpha2PredictionJob(_messages.Message):
  """Represents a specification for a prediction job.

  Fields:
    labelsPerInstance: The number of labels to predict per instance. This
      applies only to classification models, and defaults to 1, i.e., produce
      only the label with highest confidence score. If this is set to -1, all
      labels are included in the output.
    outputUri: The storage location of a folder to write out the predictions.
    predictData: The dataset to predict over.
  """

  labelsPerInstance = _messages.IntegerField(1, variant=_messages.Variant.INT32)
  outputUri = _messages.StringField(2)
  predictData = _messages.MessageField('GoogleCloudMlV1alpha2DataSet', 3)


class GoogleCloudMlV1alpha2RegressionAnalysis(_messages.Message):
  """Represents the analysis of a trained regression model.

  Fields:
    error: The root mean squared error of a regression model.
  """

  error = _messages.FloatField(1)


class GoogleCloudMlV1alpha2RegressionConfig(_messages.Message):
  """Represents the definition of a regression model.

  Fields:
    tensorflowGraph: Options for regression using a custom TensorFlow graph.
  """

  tensorflowGraph = _messages.MessageField('GoogleCloudMlV1alpha2TensorFlowGraph', 1)


class GoogleCloudMlV1alpha2StorageData(_messages.Message):
  """Represents reference to data stored in Cloud Storage. Each object is
  interpreted as a file.

  Fields:
    uris: The list of Cloud Storage URIs formatted as a complete URI such as
      Format: gs://bucket/path/to/data/file.
  """

  uris = _messages.StringField(1, repeated=True)


class GoogleCloudMlV1alpha2SubmitEvaluationJobMetadata(_messages.Message):
  """Represents the metadata on the operation resulting from
  SubmitEvaluationJob.

  Fields:
    createTime: When the job was submitted.
    endTime: When the job processing completed.
    isCancellationRequested: Whether the cancellation of the job has been
      requested.
    job: The specification of the job.
    model: The name of the model.
    operationType: The type of this operation: 'evaluation'.
    startTime: When the job processing started.
    version: The name of the model version.
  """

  createTime = _messages.StringField(1)
  endTime = _messages.StringField(2)
  isCancellationRequested = _messages.BooleanField(3)
  job = _messages.MessageField('GoogleCloudMlV1alpha2EvaluationJob', 4)
  model = _messages.StringField(5)
  operationType = _messages.StringField(6)
  startTime = _messages.StringField(7)
  version = _messages.StringField(8)


class GoogleCloudMlV1alpha2SubmitPredictionJobMetadata(_messages.Message):
  """Represents the metadata on the operation resulting from
  SubmitPredictionJob.

  Fields:
    createTime: When the job was submitted.
    endTime: When the job processing completed.
    isCancellationRequested: Whether the cancellation of the job has been
      requested.
    job: The specification of the job.
    model: The name of the model.
    operationType: The type of this operation: 'prediction'.
    startTime: When the job processing started.
    version: The name of the model version.
  """

  createTime = _messages.StringField(1)
  endTime = _messages.StringField(2)
  isCancellationRequested = _messages.BooleanField(3)
  job = _messages.MessageField('GoogleCloudMlV1alpha2PredictionJob', 4)
  model = _messages.StringField(5)
  operationType = _messages.StringField(6)
  startTime = _messages.StringField(7)
  version = _messages.StringField(8)


class GoogleCloudMlV1alpha2SubmitTrainingJobMetadata(_messages.Message):
  """Represents the metadata on the operation resulting from
  SubmitTrainingJob.

  Fields:
    createTime: When the job was submitted.
    endTime: When the job processing completed.
    isCancellationRequested: Whether the cancellation of the job has been
      requested.
    job: The specification of the job.
    model: The name of the model.
    operationType: The type of this operation: 'training'.
    startTime: When the job processing started.
    version: The name of the model version.
  """

  createTime = _messages.StringField(1)
  endTime = _messages.StringField(2)
  isCancellationRequested = _messages.BooleanField(3)
  job = _messages.MessageField('GoogleCloudMlV1alpha2TrainingJob', 4)
  model = _messages.StringField(5)
  operationType = _messages.StringField(6)
  startTime = _messages.StringField(7)
  version = _messages.StringField(8)


class GoogleCloudMlV1alpha2TensorFlowGraph(_messages.Message):
  """Represents options for using TensorFlow graph-based classification or
  regression.

  Fields:
    graphUri: The Cloud Storage location of the serialized graph definition.
      The file must represent TensorFlowGraphDefinition message in JSON
      format.
    session: The training session to use.
  """

  graphUri = _messages.StringField(1)
  session = _messages.MessageField('GoogleCloudMlV1alpha2TensorFlowSession', 2)


class GoogleCloudMlV1alpha2TensorFlowSession(_messages.Message):
  """Represents the settings used to run a TensorFlow session.

  Enums:
    ModelToKeepValueValuesEnum: Specifies which model should be kept at the
      end of the training: the model from the latest training step or the
      model with the minimum evaluation error observed during training.
      Defaults to the model from the latest step.

  Fields:
    batchSize: The number of data instances to read or process in each
      iteration step. This parameter is used to balance how quickly the model
      can be trained. Altering this parameter often requires altering learning
      rate. Decreasing batch size may require a decrease in learning rate, and
      vice-versa. Powers of two are recommended, because they can yield in
      optimizations. Typical values are between 32 and 256. This defaults to
      64.
    enableAcceleration: Whether the session should attempt to use additional
      hardware capabilities to accelerate the execution of the graph.
    modelToKeep: Specifies which model should be kept at the end of the
      training: the model from the latest training step or the model with the
      minimum evaluation error observed during training. Defaults to the model
      from the latest step.
    replicas: The number of replicas of the graph that should run in parallel
      over the data.
    steps: The number of steps to iterate over during the execution of the
      graph.
  """

  class ModelToKeepValueValuesEnum(_messages.Enum):
    """Specifies which model should be kept at the end of the training: the
    model from the latest training step or the model with the minimum
    evaluation error observed during training. Defaults to the model from the
    latest step.

    Values:
      LATEST: The latest model.
      MIN_ERROR: The model with the minimum evaluation error.
    """
    LATEST = 0
    MIN_ERROR = 1

  batchSize = _messages.IntegerField(1, variant=_messages.Variant.INT32)
  enableAcceleration = _messages.BooleanField(2)
  modelToKeep = _messages.EnumField('ModelToKeepValueValuesEnum', 3)
  replicas = _messages.IntegerField(4, variant=_messages.Variant.INT32)
  steps = _messages.IntegerField(5, variant=_messages.Variant.INT32)


class GoogleCloudMlV1alpha2TrainingJob(_messages.Message):
  """Represents a specification for a training job.

  Fields:
    evalData: The data to use for evaluating the model during training.
    model: The specification of the model to train.
    outputUri: The storage location of a folder to write out the training
      outputs, such as a model analysis, a training event log, predictions on
      the eval dataset and others.
    trainData: The data to use for training the model.
  """

  evalData = _messages.MessageField('GoogleCloudMlV1alpha2DataSet', 1)
  model = _messages.MessageField('GoogleCloudMlV1alpha2ModelSpec', 2)
  outputUri = _messages.StringField(3)
  trainData = _messages.MessageField('GoogleCloudMlV1alpha2DataSet', 4)


class GoogleCloudMlV1alpha3GetConfigResponse(_messages.Message):
  """Returns service configuration associated with a given project.

  Fields:
    serviceAccount: The service account Cloud ML uses to access resources in
      the project.
  """

  serviceAccount = _messages.StringField(1)


class GoogleCloudMlV1alpha3GetHyperparametersRequest(_messages.Message):
  """Returns the hyperparameters associated with the given run.

  Fields:
    jobName: The job name. Must be unique within the project.
    runId: The run id for these results.
  """

  jobName = _messages.StringField(1)
  runId = _messages.StringField(2)


class GoogleCloudMlV1alpha3GetHyperparametersResponse(_messages.Message):
  """Returns the hyperparameters associated with the given run.

  Messages:
    HyperparametersValue: The hyperparameters given to the requested run.

  Fields:
    hyperparameters: The hyperparameters given to the requested run.
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class HyperparametersValue(_messages.Message):
    """The hyperparameters given to the requested run.

    Messages:
      AdditionalProperty: An additional property for a HyperparametersValue
        object.

    Fields:
      additionalProperties: Additional properties of type HyperparametersValue
    """

    class AdditionalProperty(_messages.Message):
      """An additional property for a HyperparametersValue object.

      Fields:
        key: Name of the additional property.
        value: A string attribute.
      """

      key = _messages.StringField(1)
      value = _messages.StringField(2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  hyperparameters = _messages.MessageField('HyperparametersValue', 1)


class GoogleCloudMlV1alpha3HyperparameterJobResult(_messages.Message):
  """Represents the result of a hyperparameter tuning run from a training job.

  Messages:
    HyperparametersValue: The hyperparameters given to this run.

  Fields:
    bestObjectiveValue: The best objective value seen for this run.
    bestTrainingStep: The training step associated with the best objective
      value.
    hyperparameters: The hyperparameters given to this run.
    runId: The run id for these results.
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class HyperparametersValue(_messages.Message):
    """The hyperparameters given to this run.

    Messages:
      AdditionalProperty: An additional property for a HyperparametersValue
        object.

    Fields:
      additionalProperties: Additional properties of type HyperparametersValue
    """

    class AdditionalProperty(_messages.Message):
      """An additional property for a HyperparametersValue object.

      Fields:
        key: Name of the additional property.
        value: A string attribute.
      """

      key = _messages.StringField(1)
      value = _messages.StringField(2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  bestObjectiveValue = _messages.FloatField(1)
  bestTrainingStep = _messages.IntegerField(2)
  hyperparameters = _messages.MessageField('HyperparametersValue', 3)
  runId = _messages.StringField(4)


class GoogleCloudMlV1alpha3HyperparameterSpec(_messages.Message):
  """Represents a set of hyperparameters to optimize.

  Enums:
    GoalValueValuesEnum: Should the evaluation metric be maximized or
      minimized?

  Fields:
    goal: Should the evaluation metric be maximized or minimized?
    maxParallelRuns: How many training runs should be run in parallel. More
      parallelization will be faster, but parallel runs only benefit from the
      information gained by previous runs. Each run will use the number of
      workers specified by the worker, parameter server, and evaluator specs.
      Defaults to one.
    maxRuns: How many training runs should be attempted to optimize. Defaults
      to one.
    params: The set of parameters to tune.
  """

  class GoalValueValuesEnum(_messages.Enum):
    """Should the evaluation metric be maximized or minimized?

    Values:
      GOAL_TYPE_UNSPECIFIED: Goal Type will default to maximize.
      MAXIMIZE: Maximize the goal metric.
      MINIMIZE: Minimize the goal metric.
    """
    GOAL_TYPE_UNSPECIFIED = 0
    MAXIMIZE = 1
    MINIMIZE = 2

  goal = _messages.EnumField('GoalValueValuesEnum', 1)
  maxParallelRuns = _messages.IntegerField(2, variant=_messages.Variant.INT32)
  maxRuns = _messages.IntegerField(3, variant=_messages.Variant.INT32)
  params = _messages.MessageField('GoogleCloudMlV1alpha3ParameterConfig', 4, repeated=True)


class GoogleCloudMlV1alpha3JobMetadata(_messages.Message):
  """Represents the metadata of the longrunning.Operation created by the
  SubmitTrainingJob or SubmitPredictionJob method.

  Enums:
    JobStateValueValuesEnum: The detailed state of a job.

  Messages:
    StatusMetricsSnapshotValue: Progress report. A set of key-value pairs that
      convey the current state of the job.

  Fields:
    createTime: When the job was submitted.
    endTime: When the job processing was completed.
    isCancellationRequested: Whether the cancellation of this job has been
      requested.
    jobState: The detailed state of a job.
    predictionRequest: The prediction job request recorded.
    startTime: When the job processing was started.
    statusMetricsSnapshot: Progress report. A set of key-value pairs that
      convey the current state of the job.
    statusMetricsSnapshotTime: The time at which the 'status' field was
      populated.
    trainingRequest: The training job request recorded.
  """

  class JobStateValueValuesEnum(_messages.Enum):
    """The detailed state of a job.

    Values:
      UNKNOWN_JOB_STATE: <no description>
      QUEUED: <no description>
      PREPARING: <no description>
      RUNNING: <no description>
      SUCCEEDED: <no description>
      FAILED: <no description>
      CANCELLED: <no description>
    """
    UNKNOWN_JOB_STATE = 0
    QUEUED = 1
    PREPARING = 2
    RUNNING = 3
    SUCCEEDED = 4
    FAILED = 5
    CANCELLED = 6

  @encoding.MapUnrecognizedFields('additionalProperties')
  class StatusMetricsSnapshotValue(_messages.Message):
    """Progress report. A set of key-value pairs that convey the current state
    of the job.

    Messages:
      AdditionalProperty: An additional property for a
        StatusMetricsSnapshotValue object.

    Fields:
      additionalProperties: Additional properties of type
        StatusMetricsSnapshotValue
    """

    class AdditionalProperty(_messages.Message):
      """An additional property for a StatusMetricsSnapshotValue object.

      Fields:
        key: Name of the additional property.
        value: A string attribute.
      """

      key = _messages.StringField(1)
      value = _messages.StringField(2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  createTime = _messages.StringField(1)
  endTime = _messages.StringField(2)
  isCancellationRequested = _messages.BooleanField(3)
  jobState = _messages.EnumField('JobStateValueValuesEnum', 4)
  predictionRequest = _messages.MessageField('GoogleCloudMlV1alpha3SubmitPredictionJobRequest', 5)
  startTime = _messages.StringField(6)
  statusMetricsSnapshot = _messages.MessageField('StatusMetricsSnapshotValue', 7)
  statusMetricsSnapshotTime = _messages.StringField(8)
  trainingRequest = _messages.MessageField('GoogleCloudMlV1alpha3SubmitTrainingJobRequest', 9)


class GoogleCloudMlV1alpha3ListModelsResponse(_messages.Message):
  """Response message for the ListModels method.

  Fields:
    models: The list of models.
    nextPageToken: Optional pagination token to use for retrieving the next
      page of results.
  """

  models = _messages.MessageField('GoogleCloudMlV1alpha3Model', 1, repeated=True)
  nextPageToken = _messages.StringField(2)


class GoogleCloudMlV1alpha3ListVersionsResponse(_messages.Message):
  """Response message for the ListVersions method.

  Fields:
    nextPageToken: Optional pagination token to use for retrieving the next
      page of results.
    versions: The list of versions.
  """

  nextPageToken = _messages.StringField(1)
  versions = _messages.MessageField('GoogleCloudMlV1alpha3Version', 2, repeated=True)


class GoogleCloudMlV1alpha3MasterSpec(_messages.Message):
  """Represents a specification of master worker.

  Fields:
    replicaCount: The required number of master worker servers. Defaults to 1.
      If the number of replicas is greater than 1, the first master worker
      will be the one monitored for success/failure.
    resources: Resource requirements for a master. If not specified, default
      master configuration will be used.
  """

  replicaCount = _messages.IntegerField(1, variant=_messages.Variant.UINT64)
  resources = _messages.MessageField('GoogleCloudMlV1alpha3ResourceSpec', 2)


class GoogleCloudMlV1alpha3Model(_messages.Message):
  """Represents a machine learning model resource that can be used to perform
  prediction.

  Fields:
    defaultVersion: The default version of the model.
    name: The user-specified name of the model.
  """

  defaultVersion = _messages.MessageField('GoogleCloudMlV1alpha3Version', 1)
  name = _messages.StringField(2)


class GoogleCloudMlV1alpha3ParameterConfig(_messages.Message):
  """Represents a single hyperparameter to optimize.

  Enums:
    ScaleTypeValueValuesEnum: How the parameter should be scaled to the
      hypercube. Leave unset for categorical Parameters. We strongly suggest
      using some kind of scaling for real or integral parameters (e.g.,
      UNIT_LINEAR_SCALE).
    TypeValueValuesEnum: The type of the parameter.

  Fields:
    categories: The list of possible categories. REQUIRED if
      type==CATEGORICAL.
    feasiblePoints: A list of feasible points, to be provided if and only if
      type==DISCRETE. The list should be in strictly increasing order. For
      instance, this Parameter might have possible settings of 1.5, 2.5, and
      4.0. This list shouldn't be too large - probably not more than 1,000
      points.
    maxValue: max_value is REQUIRED if type==DOUBLE or type==INTEGER. This
      field should be unset if type==CATEGORICAL. This value should be
      integers if type==INTEGER.
    minValue: min_value is REQUIRED if type==DOUBLE or type==INTEGER. This
      field should be unset if type==CATEGORICAL. This value should be
      integers if type==INTEGER.
    name: The parameter name must be unique amongst all ParameterConfigs in a
      HyperparameterConfig. E.g., "learning_rate".
    scaleType: How the parameter should be scaled to the hypercube. Leave
      unset for categorical Parameters. We strongly suggest using some kind of
      scaling for real or integral parameters (e.g., UNIT_LINEAR_SCALE).
    type: The type of the parameter.
  """

  class ScaleTypeValueValuesEnum(_messages.Enum):
    """How the parameter should be scaled to the hypercube. Leave unset for
    categorical Parameters. We strongly suggest using some kind of scaling for
    real or integral parameters (e.g., UNIT_LINEAR_SCALE).

    Values:
      NONE: By default, no scaling is applied.
      UNIT_LINEAR_SCALE: Scales the feasible space to (0, 1) linearly.
      UNIT_LOG_SCALE: Scales the feasible space logarithmically to (0, 1). The
        entire feasible space must be strictly positive.
      UNIT_REVERSE_LOG_SCALE: Scales the feasible space "reverse"
        logarithmically to (0, 1). The result is that values close to the top
        of the feasible space are spread out more than points near the bottom.
        The entire feasible space must be strictly positive.
    """
    NONE = 0
    UNIT_LINEAR_SCALE = 1
    UNIT_LOG_SCALE = 2
    UNIT_REVERSE_LOG_SCALE = 3

  class TypeValueValuesEnum(_messages.Enum):
    """The type of the parameter.

    Values:
      PARAMETER_TYPE_UNSPECIFIED: Parameter type must be specified.
        Unspecified values will be treated as an error.
      DOUBLE: Type for real-valued parameters.
      INTEGER: Type for integral parameters.
      CATEGORICAL: The parameter is categorical, with a value chosen from the
        categories field.
      DISCRETE: The parameter is real valued, with a fixed set of feasible
        points. If type==DISCRETE, feasible_points must be provided, and
        {min_value, max_value} will be ignored.
    """
    PARAMETER_TYPE_UNSPECIFIED = 0
    DOUBLE = 1
    INTEGER = 2
    CATEGORICAL = 3
    DISCRETE = 4

  categories = _messages.StringField(1, repeated=True)
  feasiblePoints = _messages.FloatField(2, repeated=True)
  maxValue = _messages.FloatField(3)
  minValue = _messages.FloatField(4)
  name = _messages.StringField(5)
  scaleType = _messages.EnumField('ScaleTypeValueValuesEnum', 6)
  type = _messages.EnumField('TypeValueValuesEnum', 7)


class GoogleCloudMlV1alpha3ParameterServerSpec(_messages.Message):
  """Represents a specification of parameter servers.

  Fields:
    replicaCount: The required number of parameter servers. Defaults to 1.
    resources: Resource requirements for a single parameter server. If not
      specified, default parameter server configuration will be used.
  """

  replicaCount = _messages.IntegerField(1, variant=_messages.Variant.UINT64)
  resources = _messages.MessageField('GoogleCloudMlV1alpha3ResourceSpec', 2)


class GoogleCloudMlV1alpha3PredictRequest(_messages.Message):
  """Request for predictions to be issued against a trained model.

  Fields:
    instances: Input data, one string per instance. The type of the input data
      is stored in model metadata.
  """

  instances = _messages.StringField(1, repeated=True)


class GoogleCloudMlV1alpha3PredictResponse(_messages.Message):
  """Response with prediction tensors produced by a trained model.

  Fields:
    predictions: Predictions are produced in the same order as the input.
  """

  predictions = _messages.StringField(1, repeated=True)


class GoogleCloudMlV1alpha3PredictionJobResult(_messages.Message):
  """Represents the result of the longrunning.Operation created by the
  SubmitPredictionJob method.

  Fields:
    instancesProcessed: The number of data instances processed
    outputUri: The URI of the output dir provided at job creation time.
  """

  instancesProcessed = _messages.IntegerField(1, variant=_messages.Variant.UINT64)
  outputUri = _messages.StringField(2)


class GoogleCloudMlV1alpha3ReportMetricRequest(_messages.Message):
  """Request Metric for hyperparameter tuning metric reporting.

  Fields:
    completed: Set to true to mark this run as completed.
    jobName: The job name. Must be unique within the project.
    objectiveValue: Required.  The value of the metric being optimized.
    runId: The run to report metrics for.
    trainingStep: Optional.  What training step this metric is for.
  """

  completed = _messages.BooleanField(1)
  jobName = _messages.StringField(2)
  objectiveValue = _messages.FloatField(3)
  runId = _messages.StringField(4)
  trainingStep = _messages.IntegerField(5)


class GoogleCloudMlV1alpha3ResourceSpec(_messages.Message):
  """Resource specification for a program running inside a VM.

  Fields:
    cpus: The number of CPUs.
    disk: The required disk size (in bytes).
    gpus: The number of GPUs. Only allowed to be set within WorkerSpec.
    ram: The required RAM size (in bytes).
  """

  cpus = _messages.IntegerField(1, variant=_messages.Variant.UINT64)
  disk = _messages.IntegerField(2, variant=_messages.Variant.UINT64)
  gpus = _messages.IntegerField(3, variant=_messages.Variant.UINT64)
  ram = _messages.IntegerField(4, variant=_messages.Variant.UINT64)


class GoogleCloudMlV1alpha3SetDefaultVersionRequest(_messages.Message):
  """Request message for the SetDefaultVersion request."""


class GoogleCloudMlV1alpha3SubmitPredictionJobRequest(_messages.Message):
  """Request to submit a batch prediction job against a trained model.

  Fields:
    inputUris: URIs of the TFRecord input data files. May contain file-system
      appropriate wildcards (Google Cloud Storage prefixes, for example.).
    jobName: The job name. Must be unique within the project.
    outputUri: The uri to which output is written, a Google Cloud Storage
      prefix for example.
    parent: The name of the model against which prediction should be
      performed. It is of the form:
      /projects/project_id/models/model_name/versions/version_id. The version
      information may be omitted, in which case prediction is performed
      against the default version.
    zone: Optional. The Google Compute Engine zone to run the training job in.
      If not specified, the system will pick a zone based on the job
      requirements. It is the user's responsibility to procure quota in this
      zone.
  """

  inputUris = _messages.StringField(1, repeated=True)
  jobName = _messages.StringField(2)
  outputUri = _messages.StringField(3)
  parent = _messages.StringField(4)
  zone = _messages.StringField(5)


class GoogleCloudMlV1alpha3SubmitTrainingJobRequest(_messages.Message):
  """Request message for the SubmitTrainingJob method.

  Enums:
    LogLevelValueValuesEnum: Specify minimun log levels.
    TensorflowVersionValueValuesEnum: The version of TensorFlow to use. If
      unset, defaults to LATEST.

  Fields:
    evalDataPaths: The URIs of the data used for evaluation.
    hyperparameters: Optional set of Hyperparameters to tune.
    jobArgs: Additional command line arguments to pass to the program.
    jobName: The job name. Must be unique within the project.
    logLevel: Specify minimun log levels.
    masterSpec: Specification of master workers. The first master worker will
      be the task monitored for job success/failure.
    metadataPath: Optional. The URI of the file containing metadata.
    moduleName: The python module name to run after installing the trainer_uri
      packages. The worker will be given a flag telling the type of the
      process: worker, parameter server or evaluator. Required if docker_image
      is not set.
    outputPath: The URI of the Google Cloud Storage location to which output
      should be written. This URI may have additional subdirectories appended
      to it, e.g., during hyperparameter tuning, and the possibly modified URI
      is passed to the binary as the --output_path flag. Training binaries
      should generally respect this parameter for their output and are
      required to do so when launching from Google Cloud Dataflow or when
      using hyperparameter tuning.
    parent: The project name.
    psSpec: Specification of parameter servers.
    tensorflowVersion: The version of TensorFlow to use. If unset, defaults to
      LATEST.
    trainDataPaths: The URIs of the training data.
    trainerUri: Tarball Python Packages from Google Cloud Storage with the
      training program and any additional dependencies. At least one is
      required if docker_image is not set.
    workerSpec: Specification of workers.
    zone: Optional. The Google Compute Engine zone to run the training job in.
      If not specified, the system will pick a zone based on the job
      requirements. It is the user's responsibility to procure quota in this
      zone.
  """

  class LogLevelValueValuesEnum(_messages.Enum):
    """Specify minimun log levels.

    Values:
      UNKNOWN: No log level specified.
      DEBUG: Debug logs and above will be saved.
      INFO: Info logs and above will be saved.
      WARNING: Warning logs and above will be saved.
      ERROR: Error logs and above will be saved.
      CRITICAL: Only critical logs will be saved.
    """
    UNKNOWN = 0
    DEBUG = 1
    INFO = 2
    WARNING = 3
    ERROR = 4
    CRITICAL = 5

  class TensorflowVersionValueValuesEnum(_messages.Enum):
    """The version of TensorFlow to use. If unset, defaults to LATEST.

    Values:
      LATEST: Equivalent to the latest supported version, i.e., the last
        version in this list of enums.
      V_0_9_1: Tensorflow version 0.9.1
    """
    LATEST = 0
    V_0_9_1 = 1

  evalDataPaths = _messages.StringField(1, repeated=True)
  hyperparameters = _messages.MessageField('GoogleCloudMlV1alpha3HyperparameterSpec', 2)
  jobArgs = _messages.StringField(3, repeated=True)
  jobName = _messages.StringField(4)
  logLevel = _messages.EnumField('LogLevelValueValuesEnum', 5)
  masterSpec = _messages.MessageField('GoogleCloudMlV1alpha3MasterSpec', 6)
  metadataPath = _messages.StringField(7)
  moduleName = _messages.StringField(8)
  outputPath = _messages.StringField(9)
  parent = _messages.StringField(10)
  psSpec = _messages.MessageField('GoogleCloudMlV1alpha3ParameterServerSpec', 11)
  tensorflowVersion = _messages.EnumField('TensorflowVersionValueValuesEnum', 12)
  trainDataPaths = _messages.StringField(13, repeated=True)
  trainerUri = _messages.StringField(14, repeated=True)
  workerSpec = _messages.MessageField('GoogleCloudMlV1alpha3WorkerSpec', 15)
  zone = _messages.StringField(16)


class GoogleCloudMlV1alpha3TrainingJobResult(_messages.Message):
  """Represents the result of the longrunning.Operation created by the
  SubmitTrainingJob method.

  Fields:
    outputPath: The URI of the output location provided at job creation time.
    runs: Results for individual Hyperparameter runs.
    runsCompleted: The number of tuning runs completed successfully.
    stepsCompleted: The accomplished number of steps.
  """

  outputPath = _messages.StringField(1)
  runs = _messages.MessageField('GoogleCloudMlV1alpha3HyperparameterJobResult', 2, repeated=True)
  runsCompleted = _messages.IntegerField(3, variant=_messages.Variant.UINT64)
  stepsCompleted = _messages.IntegerField(4, variant=_messages.Variant.UINT64)


class GoogleCloudMlV1alpha3Version(_messages.Message):
  """Represents a version of the model.

  Fields:
    createTime: The creation time of the version.
    isDefault: Whether the version is default within the model.
    lastUseTime: The last usage time of the version.
    name: The user-specified name of the model version.
    originUri: Google Cloud Storage location containing the model graph,
      weights and additional metadata at the moment when the version is
      created.
  """

  createTime = _messages.StringField(1)
  isDefault = _messages.BooleanField(2)
  lastUseTime = _messages.StringField(3)
  name = _messages.StringField(4)
  originUri = _messages.StringField(5)


class GoogleCloudMlV1alpha3WorkerSpec(_messages.Message):
  """Represents a specification of training workers.

  Fields:
    replicaCount: The required number of workers. Defaults to 1.
    resources: Resource requirements for a single worker. Optional. If not
      specified, default worker configuration will be used.
  """

  replicaCount = _messages.IntegerField(1, variant=_messages.Variant.UINT64)
  resources = _messages.MessageField('GoogleCloudMlV1alpha3ResourceSpec', 2)


class GoogleLongrunningListOperationsResponse(_messages.Message):
  """The response message for Operations.ListOperations.

  Fields:
    nextPageToken: The standard List next-page token.
    operations: A list of operations that matches the specified filter in the
      request.
  """

  nextPageToken = _messages.StringField(1)
  operations = _messages.MessageField('GoogleLongrunningOperation', 2, repeated=True)


class GoogleLongrunningOperation(_messages.Message):
  """This resource represents a long-running operation that is the result of a
  network API call.

  Messages:
    MetadataValue: Service-specific metadata associated with the operation.
      It typically contains progress information and common metadata such as
      create time. Some services might not provide such metadata.  Any method
      that returns a long-running operation should document the metadata type,
      if any.
    ResponseValue: The normal response of the operation in case of success.
      If the original method returns no data on success, such as `Delete`, the
      response is `google.protobuf.Empty`.  If the original method is standard
      `Get`/`Create`/`Update`, the response should be the resource.  For other
      methods, the response should have the type `XxxResponse`, where `Xxx` is
      the original method name.  For example, if the original method name is
      `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.

  Fields:
    done: If the value is `false`, it means the operation is still in
      progress. If true, the operation is completed, and either `error` or
      `response` is available.
    error: The error result of the operation in case of failure.
    metadata: Service-specific metadata associated with the operation.  It
      typically contains progress information and common metadata such as
      create time. Some services might not provide such metadata.  Any method
      that returns a long-running operation should document the metadata type,
      if any.
    name: The server-assigned name, which is only unique within the same
      service that originally returns it. If you use the default HTTP mapping,
      the `name` should have the format of `operations/some/unique/name`.
    response: The normal response of the operation in case of success.  If the
      original method returns no data on success, such as `Delete`, the
      response is `google.protobuf.Empty`.  If the original method is standard
      `Get`/`Create`/`Update`, the response should be the resource.  For other
      methods, the response should have the type `XxxResponse`, where `Xxx` is
      the original method name.  For example, if the original method name is
      `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class MetadataValue(_messages.Message):
    """Service-specific metadata associated with the operation.  It typically
    contains progress information and common metadata such as create time.
    Some services might not provide such metadata.  Any method that returns a
    long-running operation should document the metadata type, if any.

    Messages:
      AdditionalProperty: An additional property for a MetadataValue object.

    Fields:
      additionalProperties: Properties of the object. Contains field @type
        with type URL.
    """

    class AdditionalProperty(_messages.Message):
      """An additional property for a MetadataValue object.

      Fields:
        key: Name of the additional property.
        value: A extra_types.JsonValue attribute.
      """

      key = _messages.StringField(1)
      value = _messages.MessageField('extra_types.JsonValue', 2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  @encoding.MapUnrecognizedFields('additionalProperties')
  class ResponseValue(_messages.Message):
    """The normal response of the operation in case of success.  If the
    original method returns no data on success, such as `Delete`, the response
    is `google.protobuf.Empty`.  If the original method is standard
    `Get`/`Create`/`Update`, the response should be the resource.  For other
    methods, the response should have the type `XxxResponse`, where `Xxx` is
    the original method name.  For example, if the original method name is
    `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.

    Messages:
      AdditionalProperty: An additional property for a ResponseValue object.

    Fields:
      additionalProperties: Properties of the object. Contains field @type
        with type URL.
    """

    class AdditionalProperty(_messages.Message):
      """An additional property for a ResponseValue object.

      Fields:
        key: Name of the additional property.
        value: A extra_types.JsonValue attribute.
      """

      key = _messages.StringField(1)
      value = _messages.MessageField('extra_types.JsonValue', 2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  done = _messages.BooleanField(1)
  error = _messages.MessageField('GoogleRpcStatus', 2)
  metadata = _messages.MessageField('MetadataValue', 3)
  name = _messages.StringField(4)
  response = _messages.MessageField('ResponseValue', 5)


class GoogleProtobufEmpty(_messages.Message):
  """A generic empty message that you can re-use to avoid defining duplicated
  empty messages in your APIs. A typical example is to use it as the request
  or the response type of an API method. For instance:      service Foo {
  rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty);     }  The
  JSON representation for `Empty` is empty JSON object `{}`.
  """



class GoogleRpcStatus(_messages.Message):
  """The `Status` type defines a logical error model that is suitable for
  different programming environments, including REST APIs and RPC APIs. It is
  used by [gRPC](https://github.com/grpc). The error model is designed to be:
  - Simple to use and understand for most users - Flexible enough to meet
  unexpected needs  # Overview  The `Status` message contains three pieces of
  data: error code, error message, and error details. The error code should be
  an enum value of google.rpc.Code, but it may accept additional error codes
  if needed.  The error message should be a developer-facing English message
  that helps developers *understand* and *resolve* the error. If a localized
  user-facing error message is needed, put the localized message in the error
  details or localize it in the client. The optional error details may contain
  arbitrary information about the error. There is a predefined set of error
  detail types in the package `google.rpc` which can be used for common error
  conditions.  # Language mapping  The `Status` message is the logical
  representation of the error model, but it is not necessarily the actual wire
  format. When the `Status` message is exposed in different client libraries
  and different wire protocols, it can be mapped differently. For example, it
  will likely be mapped to some exceptions in Java, but more likely mapped to
  some error codes in C.  # Other uses  The error model and the `Status`
  message can be used in a variety of environments, either with or without
  APIs, to provide a consistent developer experience across different
  environments.  Example uses of this error model include:  - Partial errors.
  If a service needs to return partial errors to the client,     it may embed
  the `Status` in the normal response to indicate the partial     errors.  -
  Workflow errors. A typical workflow has multiple steps. Each step may
  have a `Status` message for error reporting purpose.  - Batch operations. If
  a client uses batch request and batch response, the     `Status` message
  should be used directly inside batch response, one for     each error sub-
  response.  - Asynchronous operations. If an API call embeds asynchronous
  operation     results in its response, the status of those operations should
  be     represented directly using the `Status` message.  - Logging. If some
  API errors are stored in logs, the message `Status` could     be used
  directly after any stripping needed for security/privacy reasons.

  Messages:
    DetailsValueListEntry: A DetailsValueListEntry object.

  Fields:
    code: The status code, which should be an enum value of google.rpc.Code.
    details: A list of messages that carry the error details.  There will be a
      common set of message types for APIs to use.
    message: A developer-facing error message, which should be in English. Any
      user-facing error message should be localized and sent in the
      google.rpc.Status.details field, or localized by the client.
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class DetailsValueListEntry(_messages.Message):
    """A DetailsValueListEntry object.

    Messages:
      AdditionalProperty: An additional property for a DetailsValueListEntry
        object.

    Fields:
      additionalProperties: Properties of the object. Contains field @type
        with type URL.
    """

    class AdditionalProperty(_messages.Message):
      """An additional property for a DetailsValueListEntry object.

      Fields:
        key: Name of the additional property.
        value: A extra_types.JsonValue attribute.
      """

      key = _messages.StringField(1)
      value = _messages.MessageField('extra_types.JsonValue', 2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  code = _messages.IntegerField(1, variant=_messages.Variant.INT32)
  details = _messages.MessageField('DetailsValueListEntry', 2, repeated=True)
  message = _messages.StringField(3)


class MlProjectsGetConfigRequest(_messages.Message):
  """A MlProjectsGetConfigRequest object.

  Fields:
    projectsId: Part of `name`. The project name.
  """

  projectsId = _messages.StringField(1, required=True)


class MlProjectsHyperparametersRequest(_messages.Message):
  """A MlProjectsHyperparametersRequest object.

  Fields:
    googleCloudMlV1alpha3GetHyperparametersRequest: A
      GoogleCloudMlV1alpha3GetHyperparametersRequest resource to be passed as
      the request body.
    projectsId: Part of `parent`. The project name.
  """

  googleCloudMlV1alpha3GetHyperparametersRequest = _messages.MessageField('GoogleCloudMlV1alpha3GetHyperparametersRequest', 1)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsModelsCreateRequest(_messages.Message):
  """A MlProjectsModelsCreateRequest object.

  Fields:
    googleCloudMlV1alpha3Model: A GoogleCloudMlV1alpha3Model resource to be
      passed as the request body.
    projectsId: Part of `parent`. The project name.
  """

  googleCloudMlV1alpha3Model = _messages.MessageField('GoogleCloudMlV1alpha3Model', 1)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsModelsCreateVersionRequest(_messages.Message):
  """A MlProjectsModelsCreateVersionRequest object.

  Fields:
    googleCloudMlV1alpha3Version: A GoogleCloudMlV1alpha3Version resource to
      be passed as the request body.
    modelsId: Part of `parent`. See documentation of `projectsId`.
    projectsId: Part of `parent`. The name of the model.
  """

  googleCloudMlV1alpha3Version = _messages.MessageField('GoogleCloudMlV1alpha3Version', 1)
  modelsId = _messages.StringField(2, required=True)
  projectsId = _messages.StringField(3, required=True)


class MlProjectsModelsDeleteRequest(_messages.Message):
  """A MlProjectsModelsDeleteRequest object.

  Fields:
    modelsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the model.
  """

  modelsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsModelsGetRequest(_messages.Message):
  """A MlProjectsModelsGetRequest object.

  Fields:
    modelsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the model.
  """

  modelsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsModelsListRequest(_messages.Message):
  """A MlProjectsModelsListRequest object.

  Fields:
    filter: Specifies the subset of models to retrieve.
    orderBy: Specifies the ordering of the models.
    pageSize: Optional page size. The default is 100.
    pageToken: An optional pagination token, if available, for continuing the
      enumeration.
    projectsId: Part of `parent`. The name of the project whose models are to
      be listed.
  """

  filter = _messages.StringField(1)
  orderBy = _messages.StringField(2)
  pageSize = _messages.IntegerField(3, variant=_messages.Variant.INT32)
  pageToken = _messages.StringField(4)
  projectsId = _messages.StringField(5, required=True)


class MlProjectsModelsVersionsDeleteRequest(_messages.Message):
  """A MlProjectsModelsVersionsDeleteRequest object.

  Fields:
    modelsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the version.
    versionsId: Part of `name`. See documentation of `projectsId`.
  """

  modelsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)
  versionsId = _messages.StringField(3, required=True)


class MlProjectsModelsVersionsGetRequest(_messages.Message):
  """A MlProjectsModelsVersionsGetRequest object.

  Fields:
    modelsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the version.
    versionsId: Part of `name`. See documentation of `projectsId`.
  """

  modelsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)
  versionsId = _messages.StringField(3, required=True)


class MlProjectsModelsVersionsListRequest(_messages.Message):
  """A MlProjectsModelsVersionsListRequest object.

  Fields:
    filter: Specifies the subset of versions to retrieve.
    modelsId: Part of `parent`. See documentation of `projectsId`.
    orderBy: Specifies the ordering of the versions.
    pageSize: Optional page size. The default is 100.
    pageToken: An optional pagination token, if available, for continuing the
      enumeration.
    projectsId: Part of `parent`. The name of the model whose versions are to
      be listed.
  """

  filter = _messages.StringField(1)
  modelsId = _messages.StringField(2, required=True)
  orderBy = _messages.StringField(3)
  pageSize = _messages.IntegerField(4, variant=_messages.Variant.INT32)
  pageToken = _messages.StringField(5)
  projectsId = _messages.StringField(6, required=True)


class MlProjectsModelsVersionsSetDefaultRequest(_messages.Message):
  """A MlProjectsModelsVersionsSetDefaultRequest object.

  Fields:
    googleCloudMlV1alpha3SetDefaultVersionRequest: A
      GoogleCloudMlV1alpha3SetDefaultVersionRequest resource to be passed as
      the request body.
    modelsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The version name which is being made default
      within the model.
    versionsId: Part of `name`. See documentation of `projectsId`.
  """

  googleCloudMlV1alpha3SetDefaultVersionRequest = _messages.MessageField('GoogleCloudMlV1alpha3SetDefaultVersionRequest', 1)
  modelsId = _messages.StringField(2, required=True)
  projectsId = _messages.StringField(3, required=True)
  versionsId = _messages.StringField(4, required=True)


class MlProjectsOperationsCancelRequest(_messages.Message):
  """A MlProjectsOperationsCancelRequest object.

  Fields:
    operationsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the operation resource to be
      cancelled.
  """

  operationsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsOperationsDeleteRequest(_messages.Message):
  """A MlProjectsOperationsDeleteRequest object.

  Fields:
    operationsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the operation resource to be
      deleted.
  """

  operationsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsOperationsGetRequest(_messages.Message):
  """A MlProjectsOperationsGetRequest object.

  Fields:
    operationsId: Part of `name`. See documentation of `projectsId`.
    projectsId: Part of `name`. The name of the operation resource.
  """

  operationsId = _messages.StringField(1, required=True)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsOperationsListRequest(_messages.Message):
  """A MlProjectsOperationsListRequest object.

  Fields:
    filter: The standard list filter.
    pageSize: The standard list page size.
    pageToken: The standard list page token.
    projectsId: Part of `name`. The name of the operation collection.
  """

  filter = _messages.StringField(1)
  pageSize = _messages.IntegerField(2, variant=_messages.Variant.INT32)
  pageToken = _messages.StringField(3)
  projectsId = _messages.StringField(4, required=True)


class MlProjectsPredictRequest(_messages.Message):
  """A MlProjectsPredictRequest object.

  Fields:
    googleCloudMlV1alpha3PredictRequest: A GoogleCloudMlV1alpha3PredictRequest
      resource to be passed as the request body.
    projectsId: Part of `parent`. The name of the model against which
      prediction should be performed. It is of the form:
      /projects/project_id/models/model_name. The version information may be
      omitted, in which case prediction is performed against the default
      version.
  """

  googleCloudMlV1alpha3PredictRequest = _messages.MessageField('GoogleCloudMlV1alpha3PredictRequest', 1)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsReportMetricRequest(_messages.Message):
  """A MlProjectsReportMetricRequest object.

  Fields:
    googleCloudMlV1alpha3ReportMetricRequest: A
      GoogleCloudMlV1alpha3ReportMetricRequest resource to be passed as the
      request body.
    projectsId: Part of `parent`. The project name.
  """

  googleCloudMlV1alpha3ReportMetricRequest = _messages.MessageField('GoogleCloudMlV1alpha3ReportMetricRequest', 1)
  projectsId = _messages.StringField(2, required=True)


class MlProjectsSubmitTrainingJobRequest(_messages.Message):
  """A MlProjectsSubmitTrainingJobRequest object.

  Fields:
    googleCloudMlV1alpha3SubmitTrainingJobRequest: A
      GoogleCloudMlV1alpha3SubmitTrainingJobRequest resource to be passed as
      the request body.
    projectsId: Part of `parent`. The project name.
  """

  googleCloudMlV1alpha3SubmitTrainingJobRequest = _messages.MessageField('GoogleCloudMlV1alpha3SubmitTrainingJobRequest', 1)
  projectsId = _messages.StringField(2, required=True)


class StandardQueryParameters(_messages.Message):
  """Query parameters accepted by all methods.

  Enums:
    FXgafvValueValuesEnum: V1 error format.
    AltValueValuesEnum: Data format for response.

  Fields:
    f__xgafv: V1 error format.
    access_token: OAuth access token.
    alt: Data format for response.
    bearer_token: OAuth bearer token.
    callback: JSONP
    fields: Selector specifying which fields to include in a partial response.
    key: API key. Your API key identifies your project and provides you with
      API access, quota, and reports. Required unless you provide an OAuth 2.0
      token.
    oauth_token: OAuth 2.0 token for the current user.
    pp: Pretty-print response.
    prettyPrint: Returns response with indentations and line breaks.
    quotaUser: Available to use for quota purposes for server-side
      applications. Can be any arbitrary string assigned to a user, but should
      not exceed 40 characters.
    trace: A tracing token of the form "token:<tokenid>" to include in api
      requests.
    uploadType: Legacy upload protocol for media (e.g. "media", "multipart").
    upload_protocol: Upload protocol for media (e.g. "raw", "multipart").
  """

  class AltValueValuesEnum(_messages.Enum):
    """Data format for response.

    Values:
      json: Responses with Content-Type of application/json
      media: Media download with context-dependent Content-Type
      proto: Responses with Content-Type of application/x-protobuf
    """
    json = 0
    media = 1
    proto = 2

  class FXgafvValueValuesEnum(_messages.Enum):
    """V1 error format.

    Values:
      _1: v1 error format
      _2: v2 error format
    """
    _1 = 0
    _2 = 1

  f__xgafv = _messages.EnumField('FXgafvValueValuesEnum', 1)
  access_token = _messages.StringField(2)
  alt = _messages.EnumField('AltValueValuesEnum', 3, default=u'json')
  bearer_token = _messages.StringField(4)
  callback = _messages.StringField(5)
  fields = _messages.StringField(6)
  key = _messages.StringField(7)
  oauth_token = _messages.StringField(8)
  pp = _messages.BooleanField(9, default=True)
  prettyPrint = _messages.BooleanField(10, default=True)
  quotaUser = _messages.StringField(11)
  trace = _messages.StringField(12)
  uploadType = _messages.StringField(13)
  upload_protocol = _messages.StringField(14)


encoding.AddCustomJsonFieldMapping(
    StandardQueryParameters, 'f__xgafv', '$.xgafv',
    package=u'ml')
encoding.AddCustomJsonEnumMapping(
    StandardQueryParameters.FXgafvValueValuesEnum, '_1', '1',
    package=u'ml')
encoding.AddCustomJsonEnumMapping(
    StandardQueryParameters.FXgafvValueValuesEnum, '_2', '2',
    package=u'ml')
